diff -uNr ntop-3.3.8/report.c ntop-3.3.9/report.c
--- ntop-3.3.8/report.c	2008-08-17 23:06:33.000000000 +0200
+++ ntop-3.3.9/report.c	2008-12-09 12:41:47.000000000 +0100
@@ -2194,7 +2194,7 @@
     sendString("<CENTER>\n");
     safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
 		  ""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "TR_ON" "DARK_BG"><TH "TH_BG">%s0>Host%s</A></TH>\n"
-		  "<TH "TH_BG">%s1>Domain%s</A></TH>"
+		  "<TH "TH_BG">%s1>Location%s</A></TH>"
 		  "<TH "TH_BG">%s2>Pkts Sent%s</A></TH>"
 		  "<TH "TH_BG">%s3>Data Sent%s</A></TH>"
 		  "<TH "TH_BG">%s4>Pkts Rcvd%s</A></TH>"
@@ -2752,7 +2752,7 @@
 	safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
 		      "<CENTER>"TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS">\n<TR "TR_ON" "DARK_BG">"
 		      "<TH "TH_BG">%s1\">Host%s</A></TH>\n"
-		      "<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Domain%s</A></TH>\n"
+		      "<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Location%s</A></TH>\n"
 		      "<TH "TH_BG">%s2\">IP&nbsp;Address%s</A></TH>\n"
 		      "<TH "TH_BG">%s3\">MAC&nbsp;Address%s</A></TH>\n"
 		      "<TH "TH_BG">%s11\">Community%s</A></TH>\n"
@@ -2778,9 +2778,10 @@
 		      theAnchor[10], arrow[10]
 		      );
       } else {
-	safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<CENTER>"TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS">\n<TR "TR_ON" "DARK_BG">"
+	safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		      "<CENTER>"TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS">\n<TR "TR_ON" "DARK_BG">"
 		      "<TH "TH_BG">%s1\">Host%s</A></TH>\n"
-		      "<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Domain%s</A></TH>\n"
+		      "<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Location%s</A></TH>\n"
 		      "</TH><TH "TH_BG">%s2\">IP&nbsp;Address%s</A></TH>\n"
 		      "<TH "TH_BG">%s11\">Community%s</A></TH>"
 		      "<TH "TH_BG">%s6\">Other&nbsp;Name(s)%s</A></TH>\n"
@@ -3120,6 +3121,35 @@
 
 /* ************************************ */
 
+static void printHostFingerprint(HostTraffic *el) {
+  int idx;
+  char fingerprint[4096] = { '\0' };
+  for(idx=1; idx<MAX_ASSIGNED_IP_PORTS /* 1024 */; idx++) {
+    PortUsage *ports = getPortsUsage(el, idx, 0);
+    int value;
+    
+    value = 0;
+
+    if(ports != NULL) {
+      if((ports->clientUses > 0)  && (ports->serverUses > 0))
+	value = 3;
+      else if(ports->serverUses > 0)
+	value = 2;
+      else if(ports->clientUses > 0)
+	value = 1;
+    }
+
+    if(value > 0)
+      snprintf(&fingerprint[strlen(fingerprint)], 
+	       sizeof(fingerprint)-strlen(fingerprint), 
+	       "%d", value);    
+  }
+  
+  traceEvent (CONST_TRACE_WARNING, "[%s][%s]\n", el->hostNumIpAddress, fingerprint);
+}
+
+/* ************************************ */
+
 void printAllSessionsHTML(char* host, int actualDeviceId, int sortedColumn,
 			  int revertOrder, int pageNum, char *url,
 			  int hostInfoPage) {
@@ -3198,6 +3228,7 @@
     printHostContactedPeers(el, actualDeviceId);
     printHostHTTPVirtualHosts(el, actualDeviceId);
     printHostUsedServices(el, actualDeviceId);
+    printHostFingerprint(el); /* ----- **** ----- */
   } else if(foundFcHost) {
     printHTMLheader("", NULL, 0);
     printFcHostHeader(el, url, revertOrder, sortedColumn, hostInfoPage);
@@ -3466,8 +3497,8 @@
     
     sendString("<P>\n<CENTER>\n");
     sendString(""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS">\n<TR "TR_ON">");
-    if(el->clientDelay)  sendString("<TH "TH_BG" NOWRAP>Client Mode</TH>");
-    if(el ->serverDelay) sendString("<TH "TH_BG" NOWRAP>Server Mode</TH></TR>\n");
+    if(el->clientDelay)  sendString("<TH "TH_BG" NOWRAP colspan=2>Client Mode</TH>");
+    if(el ->serverDelay) sendString("<TH "TH_BG" NOWRAP colspan=2>Server Mode</TH></TR>\n");
     sendString("<TR>");
 
     if(el->clientDelay) {
@@ -3813,7 +3844,6 @@
     sendString("</CENTER>\n");
 
     printFooterHostLink();
-
   } else
     printNoDataYet();
 
@@ -5853,16 +5883,31 @@
 
     /* Split below courtesy of Andreas Pfaller <apfaller@yahoo.com.au> */
     sendString("<CENTER>\n" TABLE_ON "<TABLE BORDER=1 "TABLE_DEFAULTS">");
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
-		  "<TR "TR_ON" "DARK_BG">"
-		  "<TH "TH_BG" rowspan=\"3\">%s0>Name%s</A></TH>"
-		  "<TH "TH_BG" rowspan=\"3\">%s1>%s%s</A></TH>"
-		  "<TH "TH_BG" colspan=\"8\">TCP/IP</A></TH>"
-		  "<TH "TH_BG" colspan=\"4\">ICMP</A></TH>"
-		  "<TH "TH_BG">&nbsp;</TH></TR>\n",
-		  theAnchor[0], arrow[0],
-		  theAnchor[1], "Domains",
-		  arrow[1]);
+    
+    if(network_mode == AS_VIEW)
+      safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
+		    "<TR "TR_ON" "DARK_BG">"
+		    "<TH "TH_BG" rowspan=\"3\">%s0>Id%s</A></TH>"
+		    "<TH "TH_BG" rowspan=\"3\">Description</TH>"
+		    "<TH "TH_BG" rowspan=\"3\">%s1>%s%s</A></TH>"
+		    "<TH "TH_BG" colspan=\"8\">TCP/IP</A></TH>"
+		    "<TH "TH_BG" colspan=\"4\">ICMP</A></TH>"
+		    "<TH "TH_BG">&nbsp;</TH></TR>\n",
+		    theAnchor[0], arrow[0],
+		    theAnchor[1], "Location",
+		    arrow[1]);
+    else
+      safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
+		    "<TR "TR_ON" "DARK_BG">"
+		    "<TH "TH_BG" rowspan=\"3\">%s0>Name%s</A></TH>"
+		    "<TH "TH_BG" rowspan=\"3\">%s1>%s%s</A></TH>"
+		    "<TH "TH_BG" colspan=\"8\">TCP/IP</A></TH>"
+		    "<TH "TH_BG" colspan=\"4\">ICMP</A></TH>"
+		    "<TH "TH_BG">&nbsp;</TH></TR>\n",
+		    theAnchor[0], arrow[0],
+		    theAnchor[1], "Location",
+		    arrow[1]);
+
     sendString(buf);
 
     sendString( "<TR "TR_ON" "DARK_BG">"
@@ -5945,13 +5990,17 @@
 	  safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "as.name.%d",
 			statsEntry->domainHost->hostAS);
 
-	  if(fetchPrefsValue(buf, sym_as_name, sizeof(sym_as_name)) == -1)
-	    snprintf(sym_as_name, sizeof(sym_as_name), "%d", statsEntry->domainHost->hostAS);
+	  if(fetchPrefsValue(buf, sym_as_name, sizeof(sym_as_name)) != -1)
+	    ;	    
+	  else if(statsEntry->domainHost->hostASDescr != NULL)
+	    snprintf(sym_as_name, sizeof(sym_as_name), "%s", statsEntry->domainHost->hostASDescr);
+	  else
+	    snprintf(sym_as_name, sizeof(sym_as_name), "No Info");
 
 	  safe_snprintf(__FILE__, __LINE__, htmlAnchor, sizeof(htmlAnchor),
-			"<A HREF=/%s?dom=%d&netmode=%d>%s</A>",
+			"<A HREF=/%s?dom=%d&netmode=%d>%d</A></TH><TD "TD_BG" ALIGN=RIGHT>%s",
 			CONST_DOMAIN_STATS_HTML, statsEntry->domainHost->hostAS, network_mode,
-			sym_as_name);
+			statsEntry->domainHost->hostAS, sym_as_name);
 	} else
 	  safe_snprintf(__FILE__, __LINE__, htmlAnchor, sizeof(htmlAnchor), "<A HREF=/%s?dom=%s>%s</A>",
 			clusterMode ? CONST_CLUSTER_STATS_HTML : CONST_DOMAIN_STATS_HTML,
@@ -5995,10 +6044,10 @@
       }
 
       safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s>"
-		    "<TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=CENTER>%s</TD>"
+		    "<TH "TH_BG" ALIGN=LEFT "DARK_BG">%s%s<TD "TD_BG" ALIGN=CENTER>%s</TD>"
 		    "<TD "TD_BG" ALIGN=RIGHT>%s</TD><TD "TD_BG" ALIGN=RIGHT>%.1f%%</TD>"
 		    "<TD "TD_BG" ALIGN=RIGHT>%s</TD><TD "TD_BG" ALIGN=RIGHT>%.1f%%</TD>",
-		    getRowColor(), htmlAnchor,
+		    getRowColor(), htmlAnchor, (network_mode == AS_VIEW) ? "</TD>" : "</TH>",
 		    ((clusterMode && (!domain_network_name)) || (!statsEntry->domainHost)) ?
 		    "&nbsp;" : getHostCountryIconURL(statsEntry->domainHost),
 		    formatBytes(statsEntry->bytesSent.value, 1, formatBuf, sizeof(formatBuf)),
@@ -6065,7 +6114,7 @@
 
 	sendString("</TD>\n");
       } else {
-	traceEvent(CONST_TRACE_WARNING, "--> hostRRdGraphLink(%d)", network_mode);
+	/* traceEvent(CONST_TRACE_WARNING, "--> hostRRdGraphLink(%d)", network_mode); */
 	sendString("<TD "TD_BG" ALIGN=CENTER>&nbsp;</TD>\n");
       }
 
diff -uNr ntop-3.3.8/reportUtils.c ntop-3.3.9/reportUtils.c
--- ntop-3.3.8/reportUtils.c	2007-12-14 12:29:42.000000000 +0100
+++ ntop-3.3.9/reportUtils.c	2008-11-07 12:04:30.000000000 +0100
@@ -597,7 +597,7 @@
     safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, 
 		  ""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "TR_ON" "DARK_BG">"
 		  "<TH "TH_BG">%s"FLAG_HOST_DUMMY_IDX_STR"\">Host%s</A></TH>\n"
-		  "<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Domain%s</A></TH>"
+		  "<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Location%s</A></TH>"
 		  "<TH "TH_BG" COLSPAN=2>%s0\">Data%s</A></TH>\n",
 		  theAnchor[0], arrow[0], theAnchor[1], arrow[1],
 		  theAnchor[2], arrow[2]);
@@ -611,7 +611,8 @@
       }
 
     safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, "<TH "TH_BG">%s1\">TCP%s</A></TH>"
-		  "<TH "TH_BG">%s2\">UDP%s</A></TH><TH "TH_BG">%s3\">ICMP%s</A></TH>""<TH "TH_BG">%s4\">ICMPv6%s</A></TH>"
+		  "<TH "TH_BG">%s2\">UDP%s</A></TH><TH "TH_BG">%s3\">ICMP%s</A></TH>"
+		  "<TH "TH_BG">%s4\">ICMPv6%s</A></TH>"
 		  "<TH "TH_BG">%s5\">DLC%s</A></TH><TH "TH_BG">%s6\">IPX%s</A>"
 		  "</TH><TH "TH_BG">%s7\">IPsec%s</A></TH>"
 		  "<TH "TH_BG">%s8\">(R)ARP%s</A></TH><TH "TH_BG">%s9\">AppleTalk%s</A></TH>",
@@ -664,7 +665,7 @@
     sendString("<CENTER>\n");
     safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, ""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "TR_ON" "DARK_BG">"
 		"<TH "TH_BG">%s"FLAG_HOST_DUMMY_IDX_STR"\">Host%s</A></TH>\n"
-		"<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Domain%s</A></TH>"
+		"<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Location%s</A></TH>"
 		"<TH "TH_BG" COLSPAN=2>%s0\">Data%s</A></TH>\n",
 		theAnchor[0], arrow[0], theAnchor[1], arrow[1],
 		theAnchor[2], arrow[2]);
@@ -707,7 +708,7 @@
     sendString("<CENTER>\n");
     safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, ""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "DARK_BG">"
 		"<TH "TH_BG">%s"FLAG_HOST_DUMMY_IDX_STR"\">Host%s</A></TH>"
-		"<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Domain%s</A></TH>\n",
+		"<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Location%s</A></TH>\n",
 		theAnchor[0], arrow[0], theAnchor[1], arrow[1]);
     sendString(buf);
     j = hourId;
@@ -727,10 +728,11 @@
   case SORT_DATA_SENT_THPT:
   case SORT_DATA_THPT:
     sendString("<CENTER>\n");
-    safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, ""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "TR_ON" "DARK_BG">"
-		"<TH "TH_BG" ROWSPAN=\"2\">%s"FLAG_HOST_DUMMY_IDX_STR"\">Host%s</A></TH>"
-		"<TH "TH_BG" ROWSPAN=\"2\">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Domain%s</A></TH>\n\n",
-		theAnchor[0], arrow[0], theAnchor[1], arrow[1]);
+    safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, ""TABLE_ON
+		  "<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "TR_ON" "DARK_BG">"
+		  "<TH "TH_BG" ROWSPAN=\"2\">%s"FLAG_HOST_DUMMY_IDX_STR"\">Host%s</A></TH>"
+		  "<TH "TH_BG" ROWSPAN=\"2\">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Location%s</A></TH>\n\n",
+		  theAnchor[0], arrow[0], theAnchor[1], arrow[1]);
     sendString(buf);
 
     updateThpt(0);
@@ -762,10 +764,11 @@
     break;
   case TRAFFIC_STATS:
     sendString("<CENTER>\n");
-    safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, ""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "TR_ON" "DARK_BG">"
-		"<TH "TH_BG">%s"FLAG_HOST_DUMMY_IDX_STR"\">Host%s</A></TH>"
-		"<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Domain%s</A></TH>\n\n",
-		theAnchor[0], arrow[0], theAnchor[1], arrow[1]);
+    safe_snprintf(__FILE__, __LINE__, buf, LEN_GENERAL_WORK_BUFFER, 
+		  ""TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS"><TR "TR_ON" "DARK_BG">"
+		  "<TH "TH_BG">%s"FLAG_HOST_DUMMY_IDX_STR"\">Host%s</A></TH>"
+		  "<TH "TH_BG">%s"FLAG_DOMAIN_DUMMY_IDX_STR"\">Location%s</A></TH>\n\n",
+		  theAnchor[0], arrow[0], theAnchor[1], arrow[1]);
     sendString(buf);
     break;
   }
@@ -1085,6 +1088,24 @@
 
 /* ******************************* */
 
+int cmpFctnLocationName(const void *_a, const void *_b) {
+  HostTraffic **a = (HostTraffic **)_a;
+  HostTraffic **b = (HostTraffic **)_b;
+  char *c_a = "", *c_b = "";
+
+  if((a != NULL) && (*a != NULL)
+     && (*a)->geo_ip && ((*a)->geo_ip->country_code != NULL))
+    c_a = (*a)->geo_ip->country_code;
+
+  if((b != NULL) && (*b != NULL) 
+     && (*b)->geo_ip && ((*b)->geo_ip->country_code != NULL))
+    c_b = (*b)->geo_ip->country_code;
+  
+  return(strcmp(c_a, c_b));
+}
+
+/* ******************************* */
+
 int cmpFctn(const void *_a, const void *_b) {
   HostTraffic **a = (HostTraffic **)_a;
   HostTraffic **b = (HostTraffic **)_b;
@@ -3493,12 +3514,10 @@
   sendString("<CENTER>\n<P>"TABLE_ON"<TABLE BORDER=1 "TABLE_DEFAULTS" WIDTH=80%%>\n");
 
   if(el->hostNumIpAddress[0] != '\0') {
-    char *countryIcon, *hostType, tmpBuf[64];
+    char *hostType, tmpBuf[64];
 
     accessAddrResMutex("printAllSessions-2");
 
-    countryIcon = getHostCountryIconURL(el);
-
     if(broadcastHost(el)) hostType = "broadcast";
     else if(multicastHost(el)) hostType = "multicast";
     else hostType = "unicast";
@@ -3519,11 +3538,10 @@
       multivlaned = "";
 
     safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH>"
-		"<TD "TD_BG" ALIGN=RIGHT>%s&nbsp;%s&nbsp;[%s%s%s%s]",
-		getRowColor(),
-		"IP&nbsp;Address",
-		el->hostNumIpAddress,
-		countryIcon, hostType, dynIp, multihomed, multivlaned);
+		  "<TD "TD_BG" ALIGN=RIGHT>%s&nbsp;[%s%s%s%s]",
+		  getRowColor(),
+		  "IP&nbsp;Address", el->hostNumIpAddress,
+		  hostType, dynIp, multihomed, multivlaned);
     sendString(buf);
 
     safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
@@ -3663,8 +3681,10 @@
       safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH>"
 		  "<TD "TD_BG" ALIGN=RIGHT>%s</TD><TD "TD_BG" ALIGN=RIGHT>%s</TD></TR>\n",
 		  getRowColor(), "DHCP Unknown Msg",
-		  formatPkts(el->protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_UNKNOWN_MSG].value, formatBuf, sizeof(formatBuf)),
-		  formatPkts(el->protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_UNKNOWN_MSG].value, formatBuf1, sizeof(formatBuf1)));
+		  formatPkts(el->protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_UNKNOWN_MSG].value, 
+			     formatBuf, sizeof(formatBuf)),
+		  formatPkts(el->protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_UNKNOWN_MSG].value,
+			     formatBuf1, sizeof(formatBuf1)));
       sendString(buf);
 
       sendString("</TABLE>"TABLE_OFF"</TD></TR>\n");
@@ -3693,10 +3713,14 @@
 	      formatSeconds(myGlobals.actTime-el->lastSeen, formatBuf2, sizeof(formatBuf2)));
   sendString(buf);
 
+
   if(el->hostAS != 0) {
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
-		"<A class=external HREF=\"http://ws.arin.net/cgi-bin/whois.pl?queryinput=AS%d\">%d</A></TD></TR>\n",
-		getRowColor(), "Autonomous System", el->hostAS, el->hostAS);
+    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		  "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
+		  "<A class=external HREF=\"http://ws.arin.net/cgi-bin/whois.pl?queryinput=AS%d\">%d</A>"
+		  "&nbsp;[%s]</TD></TR>\n",
+		  getRowColor(), "Autonomous System", 
+		  el->hostAS, el->hostAS, (el->hostASDescr != NULL) ? el->hostASDescr : "No AS info");
     sendString(buf);
   }
 
@@ -3706,16 +3730,18 @@
 
     host2networkName(el, subnet_buf, sizeof(subnet_buf));
 
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
+    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		  "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
 		  "<A HREF=\""CONST_DOMAIN_STATS_HTML"?dom=%d&netmode=1\">%s</A></TD></TR>\n", getRowColor(),
 		  "Subnet", el->known_subnet_id, subnet_buf);
     sendString(buf);
   }
 
   if(el->dnsDomainValue && (el->dnsDomainValue[0] != '\0')) {
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
-		"%s</TD></TR>\n", getRowColor(),
-		"Domain", el->dnsDomainValue);
+    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		  "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
+		  "%s</TD></TR>\n", getRowColor(),
+		  "Domain", el->dnsDomainValue);
     sendString(buf);
   }
 
@@ -3924,14 +3950,29 @@
 		    "Host&nbsp;Location", 
 		    "Local (inside specified/local subnet or known network list)");
     } else {
-      safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
-		  "%s</TD></TR>\n", getRowColor(),
-		  "Host&nbsp;Location",
-		  "Remote (outside specified/local subnet)");
+      safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		    "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
+		    "%s</TD></TR>\n", getRowColor(),
+		    "Host&nbsp;Location",
+		    "Remote (outside specified/local subnet)");
     }
     sendString(buf);
   }
 
+
+  if(el->geo_ip) {
+    char *countryIcon, buf3[512] = { '\0' };
+    
+    if(myGlobals.runningPref.mapperURL) buildMapLink(el, buf3, sizeof(buf3));
+    countryIcon = getHostCountryIconURL(el);
+
+    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		  "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
+		  "%s, %s %s&nbsp;%s&nbsp;</TD></TR>\n", getRowColor(), "Physical Location", 
+		  el->geo_ip->city ? el->geo_ip->city : "Unknown city", el->geo_ip->country_name, countryIcon, buf3);
+    sendString(buf);
+  }
+
   if(el->community) {
     safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
 		  "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
@@ -3972,14 +4013,16 @@
 	      );
   sendString(buf);
 
-  safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
+  safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
+		"<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
 	      "%s Pkts</TD></TR>\n",
 	      getRowColor(), "Broadcast&nbsp;Pkts&nbsp;Sent",
 	      formatPkts(el->pktBroadcastSent.value, formatBuf, sizeof(formatBuf)));
   sendString(buf);
 
   if(el->routedTraffic != NULL) {
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR  "TR_ON"%s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
+    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
+		  "<TR  "TR_ON"%s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>"
 		"%s/%s Pkts</TD></TR>\n",
 		getRowColor(), "Routed Traffic",
 		formatBytes(el->routedTraffic->routedBytes.value, 1, formatBuf, sizeof(formatBuf)),
@@ -3988,7 +4031,8 @@
   }
 
   if((el->pktMulticastSent.value > 0) || (el->pktMulticastRcvd.value > 0)) {
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>",
+    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		  "<TR "TR_ON" %s><TH "TH_BG" ALIGN=LEFT "DARK_BG">%s</TH><TD "TD_BG" ALIGN=RIGHT>",
 		getRowColor(), "Multicast&nbsp;Traffic");
     sendString(buf);
 
@@ -4128,14 +4172,7 @@
 		  "[ <A class=external HREF=\"http://ws.arin.net/cgi-bin/whois.pl?queryinput=%s\">Whois</A> ]\n",
 		  getRowColor(), "Further Host Information", el->hostNumIpAddress);
     sendString(buf);
-    
-    if(myGlobals.runningPref.mapperURL) {      
-      sendString(" [");
-      buildMapLink(el, buf, sizeof(buf));
-      sendString(buf);
-      sendString(" ]");
-    }
-    
+        
     sendString("</TD></TR>\n");
   }
 
@@ -5334,14 +5371,27 @@
 void buildMapLink(HostTraffic *el, char *buf, int buf_len) {
   if(privateIPAddress(el))
     buf[0] = '\0';
-  else
+  else {
+#if 0
     safe_snprintf(__FILE__, __LINE__, buf, buf_len,
-		" <A class=external href=\"#\" title=\"Physical Host Location\"onclick=\"window.open(\'%s?host=%s@%s\', "
+		" <A class=external href=\"#\" title=\"Physical Host Location\" "
+		  "onclick=\"window.open(\'%s?host=%s@%s\', "
 		  "\'Host Map\', \'height=210, width=320,toolbar=nodirectories=no,status=no,"
 		  "menubar=no,scrollbars=no,resizable=no\'); return false;\">"
 		  "<IMG SRC=/marker.png border=0></A>\n",
 		  myGlobals.runningPref.mapperURL,
 		  el->hostResolvedName, el->hostNumIpAddress);
+#else
+    safe_snprintf(__FILE__, __LINE__, buf, buf_len,
+		  " <A class=external href=\"#\" title=\"Physical Host Location\" "
+		  "onclick=\"window.open(\'%s?host=%s&ip=%s\', "
+		  "\'Host Map\', \'height=530, width=750,toolbar=nodirectories=no,status=no,"
+		  "menubar=no,scrollbars=no,resizable=no\'); return false;\">"
+		  "<IMG SRC=/marker.png border=0></A>\n",
+		  myGlobals.runningPref.mapperURL,
+		  el->hostResolvedName, el->hostNumIpAddress);
+#endif
+  }
 }
 
 /* ************************************ */
